Grouped Stacked Bar in JavaScript

Using ApexCharts with JavaScript

This Grouped Stacked Bar example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      name: 'Q1 Budget',
      group: 'budget',
      color: '#80c7fd',
      data: [44000, 55000, 41000, 67000, 22000],
    },
    {
      name: 'Q1 Actual',
      group: 'actual',
      color: '#008FFB',
      data: [48000, 50000, 40000, 65000, 25000],
    },
    {
      name: 'Q2 Budget',
      group: 'budget',
      color: '#80f1cb',
      data: [13000, 36000, 20000, 8000, 13000],
    },
    {
      name: 'Q2 Actual',
      group: 'actual',
      color: '#00E396',
      data: [20000, 40000, 25000, 10000, 12000],
    },
  ],
  chart: {
    type: 'bar',
    height: 350,
    stacked: true,
  },
  stroke: {
    width: 1,
    colors: ['#fff'],
  },
  dataLabels: {
    formatter: (val) => {
      return val / 1000 + 'K'
    },
  },
  plotOptions: {
    bar: {
      horizontal: true,
    },
  },
  xaxis: {
    categories: [
      'Online advertising',
      'Sales Training',
      'Print advertising',
      'Catalogs',
      'Meetings',
    ],
    labels: {
      formatter: (val) => {
        return val / 1000 + 'K'
      },
    },
  },
  fill: {
    opacity: 1,
  },
  legend: {
    position: 'top',
    clusterGroupedSeriesOrientation: 'horizontal',
    horizontalAlign: 'left',
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Grouped Stacked Bar in Vue

Using ApexCharts with Vue

This Grouped Stacked Bar example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="bar"
        height="350"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Q1 Budget',
          group: 'budget',
          color: '#80c7fd',
          data: [44000, 55000, 41000, 67000, 22000],
        },
        {
          name: 'Q1 Actual',
          group: 'actual',
          color: '#008FFB',
          data: [48000, 50000, 40000, 65000, 25000],
        },
        {
          name: 'Q2 Budget',
          group: 'budget',
          color: '#80f1cb',
          data: [13000, 36000, 20000, 8000, 13000],
        },
        {
          name: 'Q2 Actual',
          group: 'actual',
          color: '#00E396',
          data: [20000, 40000, 25000, 10000, 12000],
        },
      ],
      chartOptions: {
        chart: {
          type: 'bar',
          height: 350,
          stacked: true,
        },
        stroke: {
          width: 1,
          colors: ['#fff'],
        },
        dataLabels: {
          formatter: (val) => {
            return val / 1000 + 'K'
          },
        },
        plotOptions: {
          bar: {
            horizontal: true,
          },
        },
        xaxis: {
          categories: [
            'Online advertising',
            'Sales Training',
            'Print advertising',
            'Catalogs',
            'Meetings',
          ],
          labels: {
            formatter: (val) => {
              return val / 1000 + 'K'
            },
          },
        },
        fill: {
          opacity: 1,
        },
        legend: {
          position: 'top',
          clusterGroupedSeriesOrientation: 'horizontal',
          horizontalAlign: 'left',
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Grouped Stacked Bar in React

Using ApexCharts with React

This Grouped Stacked Bar example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Q1 Budget',
        group: 'budget',
        color: '#80c7fd',
        data: [44000, 55000, 41000, 67000, 22000],
      },
      {
        name: 'Q1 Actual',
        group: 'actual',
        color: '#008FFB',
        data: [48000, 50000, 40000, 65000, 25000],
      },
      {
        name: 'Q2 Budget',
        group: 'budget',
        color: '#80f1cb',
        data: [13000, 36000, 20000, 8000, 13000],
      },
      {
        name: 'Q2 Actual',
        group: 'actual',
        color: '#00E396',
        data: [20000, 40000, 25000, 10000, 12000],
      },
    ],
    options: {
      chart: {
        type: 'bar',
        height: 350,
        stacked: true,
      },
      stroke: {
        width: 1,
        colors: ['#fff'],
      },
      dataLabels: {
        formatter: (val) => {
          return val / 1000 + 'K'
        },
      },
      plotOptions: {
        bar: {
          horizontal: true,
        },
      },
      xaxis: {
        categories: [
          'Online advertising',
          'Sales Training',
          'Print advertising',
          'Catalogs',
          'Meetings',
        ],
        labels: {
          formatter: (val) => {
            return val / 1000 + 'K'
          },
        },
      },
      fill: {
        opacity: 1,
      },
      legend: {
        position: 'top',
        clusterGroupedSeriesOrientation: 'horizontal',
        horizontalAlign: 'left',
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="bar"
          height={350}
        />
      </div>
    </div>
  )
}

export default ApexChart

Grouped Stacked Bar in Angular

Using ApexCharts with Angular

This Grouped Stacked Bar example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Q1 Budget',
              group: 'budget',
              color: '#80c7fd',
              data: [44000, 55000, 41000, 67000, 22000],
            },
            {
              name: 'Q1 Actual',
              group: 'actual',
              color: '#008FFB',
              data: [48000, 50000, 40000, 65000, 25000],
            },
            {
              name: 'Q2 Budget',
              group: 'budget',
              color: '#80f1cb',
              data: [13000, 36000, 20000, 8000, 13000],
            },
            {
              name: 'Q2 Actual',
              group: 'actual',
              color: '#00E396',
              data: [20000, 40000, 25000, 10000, 12000],
            },
          ],
          chart: {
            type: 'bar',
            height: 350,
            stacked: true,
          },
          stroke: {
            width: 1,
            colors: ['#fff'],
          },
          dataLabels: {
            formatter: (val) => {
              return val / 1000 + 'K'
            },
          },
          plotOptions: {
            bar: {
              horizontal: true,
            },
          },
          xaxis: {
            categories: [
              'Online advertising',
              'Sales Training',
              'Print advertising',
              'Catalogs',
              'Meetings',
            ],
            labels: {
              formatter: (val) => {
                return val / 1000 + 'K'
              },
            },
          },
          fill: {
            opacity: 1,
          },
          legend: {
            position: 'top',
            clusterGroupedSeriesOrientation: 'horizontal',
            horizontalAlign: 'left',
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}